// TorbotDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DDJ.h"
#include "spiritctl.h"
#include "TorbotDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// TorbotDlg dialog


TorbotDlg::TorbotDlg(CWnd* pParent /*=NULL*/)
	: CDialog(TorbotDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(TorbotDlg)
	m_status = _T("");
	//}}AFX_DATA_INIT
  m_LeftHits = 0;
  m_RightHits = 0;
}


void TorbotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(TorbotDlg)
	DDX_Control(pDX, IDC_STOP, m_stop);
	DDX_Control(pDX, IDC_START, m_start);
	DDX_Control(pDX, IDC_DOWNLOAD, m_download);
	DDX_Control(pDX, IDC_SPIRITCTRL1, m_spirit);
	DDX_Text(pDX, IDC_STATUS, m_status);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(TorbotDlg, CDialog)
	//{{AFX_MSG_MAP(TorbotDlg)
	ON_BN_CLICKED(IDC_DOWNLOAD, OnDownload)
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TorbotDlg message handlers

BEGIN_EVENTSINK_MAP(TorbotDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(TorbotDlg)
	ON_EVENT(TorbotDlg, IDC_SPIRITCTRL1, 2 /* VariableChange */, OnVariableChangeSpiritctrl1, VTS_I2 VTS_I2)
	ON_EVENT(TorbotDlg, IDC_SPIRITCTRL1, 4 /* DownloadDone */, OnDownloadDoneSpiritctrl1, VTS_I2 VTS_I2)
	ON_EVENT(TorbotDlg, IDC_SPIRITCTRL1, 6 /* AsyncronBrickError */, OnAsyncronBrickErrorSpiritctrl1, VTS_I2 VTS_PBSTR)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void TorbotDlg::OnDownload() 
{
  m_spirit.SelectPrgm( PROGRAM_5 );  // program 5

  m_spirit.BeginOfTask( TASK_0 );     // start task generation
  {
    m_spirit.SetVar( VAR_0, SRC_CONSTANT,0 );   // set var0 to 0
    // set sensor 1 to switch
    m_spirit.SetSensorType( SENSOR_1, SENSOR_TYPE_SWITCH );
    m_spirit.SetSensorMode( SENSOR_1, SENSOR_MODE_BOOLEAN, 0 );
    // set sensor 3 to switch
    m_spirit.SetSensorType( SENSOR_3, SENSOR_TYPE_SWITCH );     
    m_spirit.SetSensorMode( SENSOR_3, SENSOR_MODE_BOOLEAN, 0 );

    m_spirit.Loop( SRC_CONSTANT,INFINITE_LOOP );  // loop forever
    {
      // is switch on 1 ?
      m_spirit.If( SRC_SENSOR_VALUE, SENSOR_1, OP_EQUAL,
                   SRC_CONSTANT, 1 );
      {
        // are we still processing the variable ?
        m_spirit.If( SRC_VARIABLE, VAR_0, OP_EQUAL,
                     SRC_CONSTANT, 0 );
        {
          // turn off motors
          m_spirit.Off( MOTOR_AC );
          // set var0 to 1
          m_spirit.SetVar( VAR_0, SRC_CONSTANT, 1 );
          // slight delay to let event fire
          m_spirit.Wait( SRC_CONSTANT, 20 );         
        }
        m_spirit.EndIf();
      }
      m_spirit.EndIf();
      // is switch on 3 ?
      m_spirit.If( SRC_SENSOR_VALUE, SENSOR_3, OP_EQUAL,
                   SRC_CONSTANT, 1 );
      {
        // are we still processing the variable ?
        m_spirit.If( SRC_VARIABLE, VAR_0, OP_EQUAL,
                   SRC_CONSTANT, 0 );
        {
          // turn off motors
          m_spirit.Off( MOTOR_AC );
          // set var0 to 2
          m_spirit.SetVar( VAR_0, SRC_CONSTANT, 2 );
          // slight delay to let event fire
          m_spirit.Wait( SRC_CONSTANT, 20 );         
        }
        m_spirit.EndIf();
      }
      m_spirit.EndIf();
    }
    m_spirit.EndLoop();
  }
  m_spirit.EndOfTask();   // starts the download
}

void TorbotDlg::OnStart() 
{
  m_spirit.Off( MOTOR_AC );       // start in a known state
  // motors at max power
  m_spirit.SetPower( MOTOR_AC, SRC_CONSTANT, POWER_FULL );  
  m_spirit.SetFwd( MOTOR_A );     // these directions make
  m_spirit.SetRwd( MOTOR_C );     //  both treads run forward

  // setup to receive var0 changes every 10ms
  m_spirit.SetEvent( SRC_VARIABLE, VAR_0, 10 );          
  m_spirit.StartTask( TASK_0 );   // turn on task 0
  m_spirit.On( MOTOR_AC );        // startup the motors
}

void TorbotDlg::OnStop() 
{
  m_spirit.StopAllTasks();        // stops task 0 (any task really)
  // stop receiving events
  m_spirit.ClearEvent( SRC_VARIABLE, VAR_0 );           
  m_spirit.Off( MOTOR_AC );       // turn off the motors
}

void TorbotDlg::OnVariableChangeSpiritctrl1(short Number, short Value) 
{
  //
  // Without the ClearEvent/SetEvent the VariableChange method is
  // not called if the last value is the same as the previous.
  // This means if I hold down one of the sensors, the RCX program
  // will stop the motors and set var0 but this will not cause
  // an event since the var0 value is the same as the last one.
  // Using ClearEvent/SetEvent, I can force the event.
  // 
  m_spirit.ClearEvent( SRC_VARIABLE, VAR_0 );           
  switch( Value )
  {
    case 1:
      m_LeftHits++;
      m_spirit.AlterDir( MOTOR_AC );             // backup
      m_spirit.On( MOTOR_AC );
      m_spirit.PlaySystemSound( SOUND_CLICK );   // lil' beep
      ::Sleep( 300 );                            // .3 second delay
      m_spirit.AlterDir( MOTOR_A );              // turn right
      ::Sleep( 300 );                            // .3 second delay
      m_spirit.AlterDir( MOTOR_C );              // go straight
      m_spirit.SetVar( VAR_0, SRC_CONSTANT, 0 ); // reset var0
      break;
    case 2:
      m_RightHits++;
      m_spirit.AlterDir( MOTOR_AC );             // backup
      m_spirit.On( MOTOR_AC );
      m_spirit.PlaySystemSound( SOUND_CLICK );   // lil' beep
      ::Sleep( 300 );                            // .3 second delay
      m_spirit.AlterDir( MOTOR_C );              // turn left
      ::Sleep( 300 );                            // .3 second delay
      m_spirit.AlterDir( MOTOR_A );              // go straight
      m_spirit.SetVar( VAR_0, SRC_CONSTANT, 0 ); // reset var0
      break;
  }
  m_spirit.SetEvent( SRC_VARIABLE, VAR_0, 10 );  // re-enable event

  // show number of hits in dialog
  m_status.Format( "Left hits=%d   Right hits=%d", m_LeftHits, m_RightHits );
  UpdateData( FALSE );
}

void TorbotDlg::OnDownloadDoneSpiritctrl1(short ErrorCode, short DownloadNo) 
{
  m_spirit.PlaySystemSound( SOUND_SWEEP_UP );   // beep like in Mindstorms
  if( ErrorCode != 0 )
  {
    m_status.Format( "Error %d", (int)ErrorCode );
    UpdateData( FALSE );
  }
}

void TorbotDlg::OnAsyncronBrickErrorSpiritctrl1(short Number, BSTR FAR* Description) 
{
  // called when an error occurs
  m_status = *Description;
  UpdateData( FALSE );
}

BOOL TorbotDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
  //
  // First API to be called should be InitComm()
  //
  if( m_spirit.InitComm() )
  {
    if( m_spirit.TowerAndCableConnected() )
    {
      if( m_spirit.TowerAlive() == FALSE )
      {
        AfxMessageBox( "Tower not alive.\nCheck connection and battery" );
      }
    }
    else
    {
      AfxMessageBox( "Tower not connected to computer.\nProgram cannot be downloaded" );
    }
  }
  else
  {
    AfxMessageBox( "Could not initialize communication" );
  }
  
  return TRUE;
}
