package com.cl.exception;

import java.net.*;
import java.io.*;

/**
 * This type was created in VisualAge.
 */
public class MailHandler implements Handler {
	private String developerOnCall = null;
/**
 * Mailer constructor comment.
 */
public MailHandler(String aOnCallDeveloper) {
	super();
	developerOnCall = aOnCallDeveloper;
}
/**
 * Notify on call develoepr of exception event using the 
 * mailto: URL .
 */
public void handle(ExceptionEvent event) {


	// Set the default mail server -- This could be gotten from a properties file
	System.getProperties().put("mail.host", "smtp.crosslogic.com");	
		
	// Create a MailTo URL
	String url = "mailto:" + developerOnCall;
		
	try {	
		URL u = new URL(url);    									
		URLConnection c = u.openConnection();	
		c.setDoInput(false);				//no input
		c.setDoOutput(true);				//there is output
		c.connect();						//connect to mail host

		// Create writer for output
		PrintWriter mailout = new PrintWriter(new OutputStreamWriter(c.getOutputStream()));
	
		//Write headers.
		String headerLine = "From:  \"" + "webmaster@crosslogic.com" + "\" <formtest@crosslogic.com>";
		mailout.println(headerLine);
		
		headerLine = "To:  \"" + developerOnCall+ "\"";
		mailout.println(headerLine);
		mailout.println();  	//blank line to end the list of headers

		mailout.println(event.info());
		mailout.close();
	
	} catch (java.io.IOException e) {
		Dispatch.handleUsingDefault(e);
		
	}	

}
	
}